#!/usr/bin/perl -w
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#  Folding @ Home script for irssi; requires curls installed
#
#*********************************** 
# IMPORTANT: SET UP YOUR F@H-PATH! *
#***********************************

use strict;
use Irssi;
use vars qw($VERSION %IRSSI);
$VERSION = '1.00';
%IRSSI = (
    authors     => 'Haui',
    contact     => 'haui45@web.de',
    name        => 'fah stats',
    description => 'This script allows ' .
                   'you to print your ' .
                   'folding @ home stats in irssi',
    license     => 'GPL',
);

#********************************************************************
my @fahpaths = (
	"/path/to/fah1/",
	"/path/to/fah2/",
	);
#********************************************************************

my $curl="curl &> /dev/null http://vspx27.stanford.edu/teamstats/team";
my @strings;
Irssi::print("fah stats successfully loaded! Response time of the script may vary, see code for details.");

 sub irssi_stuff {
	# server - the active server in window
	# witem - the active window item (eg. channel, query)
	#         or undef if the window is empty
	my ($data, $server, $witem) = @_;

	if (!$server || !$server->{connected}) {
		Irssi::print("Not connected to server");
		return;
	}
	if (fah() == -1){return;}
	if (fah() == -2){
		Irssi:print("Problem with unitinfo.txt...is your path correct?");
		return;
	}
	if (fah() == -3){
		Irssi:print("Problem with client.cfg...is your path correct?");
		return;
	}
	if (fah() == -4){
		Irssi:print("something went wrong....fix it! :-) ");
		return;
	}

	if ($data) {
		Irssi::print("There are no command switches ;)");
		return;
	} elsif ($witem && ($witem->{type} eq "CHANNEL" ||
			$witem->{type} eq "QUERY")) {
		# there's query/channel active in window
		foreach my $string (@strings){
			$witem->command("SAY $string");
		}
	} else {
		Irssi::print("No active channel/query in window");
	}    
}

sub fah {
	my $i = 0;
	foreach my $fahpath (@fahpaths){
		my ($unitinfo, $cfg, $wu, $dltime, $duetime, $progress, $name,
			$team, @stats,  $line);
		my $unitinfo=$fahpath . "/unitinfo.txt";
		my $cfg=$fahpath . "/client.cfg";
		if ($unitinfo =~ m/^\/path\/to\/fah.*/){		#just in case...
			Irssi::print ("Please set your f\@h path!");
			return -1;
		}

		open(INFILE, $unitinfo) or return -2;

		while ($line = <INFILE>){
			if ($line =~ m/^Name:/) {$wu=$line; chomp($wu);}
			elsif ($line =~ m/^Download/)  {$dltime=$line; chomp($dltime);}
			elsif ($line =~m/^Due/) {$duetime=$line; chomp($duetime);}
			elsif ($line =~m/^Progress/) {$progress=$line; chomp($progress);}
		}
		close INFILE;


		open (INFILE, $cfg) or return -3;

		while($line = <INFILE>){
			if ($line =~ m/^username/){	#get username
				$name = $line;
				$name =~ s/username=//;
				chomp($name);
			}
			if ($line =~ m/^team/){		#get Team-Id
				$team=$line;
				$team =~ s/team=//;
				chomp($team);
				last;
			}
		}
		close INFILE;
		if ($team == 446 || $team == 0){			#remove this if your connection is fast enough...
			print "teamstats file is too large ;p\n";	#
			exit(1);					#
		}							#

		$curl=$curl.$team.".txt > /tmp/team.txt";
		system($curl);

		 
		open(INFILE, "/tmp/team.txt") or return -4;
		while($line = <INFILE>){
			unless($line =~ /^\n$/ ){
				@stats = split /\t/, $line;
				if ($stats[2]){
					if ($stats[2] =~  $name){
						last;
					}
				}
			}
		}
		$strings[$i] = "[Core $i] User: $name - Team: $team - team rank: $stats[1] - overall rank: $stats[0] - credit: $stats[3] || " .
			"[wu] $wu - $dltime - $duetime - $progress";

		unlink("/tmp/team.txt");
		$i++;
	}
}

Irssi::command_bind('fah', 'irssi_stuff');
